#!/usr/bin/perl -w
use strict;
use Cwd;

################################
my %global = (
              qsub        => "qsub",
#	      mead_path   => "/scratch/btbs08/my_mead",
	      mead_path   => "/sw/sci/app/mead_64/my_mead_09",
              epath       => "./err",
              opath       => "./out",
	      memory      => "2000MB",
	      nodes       => "1"
             );
################################
#queues => "barney.q,bart.q,burns.q,carl.q,homer.q,krusty.q,lenny.q,lisa.q,maggie.q,marge.q,milhouse.q,moe.q,patty.q,quimby.q,selma.q,smithers.q,wiggum.q",
	
# takes job.sh from GCEM, run pqr2SolvAccVol, make submit script for each my_?diel_solver and submit

if (not -d $global{epath}){mkdir $global{epath};}
if (not -d $global{opath}){mkdir $global{opath};}

my $wd = cwd();
my @directory = split("/", sprintf("%s", cwd()));
my $numlevel = 0;
foreach my $level (@directory){
 $numlevel ++;
}
my $thirdlevel = $numlevel - 3;

my $jobname = "GCEM.$directory[$thirdlevel]";

my $maxjobsinscript = 4;
my $numberjobs = 0;
my $numberscripts = 0;
my $jobnum = 0;

while (<>) {
 next if (/bin\/sh|^#|^\s*\n/);
 s/[\\]//g;
 if (/pqr2(Solv|Ion)AccVol/){
  print $_;
  system ("$_");
 } 
 elsif (/my_((\d+|N)diel|memb)_solver\s+.+[\s\^s]*\s+[>]{1}\s+([^\s]+)\n/){
  my $tmpfile = $3;
  my $redo = 0;
  if ($jobnum == $maxjobsinscript){
   close (FH);
   system ("$global{qsub} -N $jobname -l mem=$global{memory} gcem_job.csh");
   $jobnum = 0;
  }
  if (-e "$tmpfile"){
   my $tmp = $_;
   my $ok = 0;
   open (INB, $tmpfile) || die "Input file ".$2."not found\n";
    while (<INB>){
     if (/^Total runtime/){$ok = 1;}
    }
   close (INB);
   $_ = $tmp;
   if ($ok != 1){
    print "Output $3 is incomplete, will be redone ...\n";  
    $redo = 1;
    system("rm $tmpfile");
   }
  }
  if ($jobnum == 0 && ((not (-e $tmpfile)) || ($redo == 1))){
   open (FH, ">gcem_job.csh") || die "Can't open submit.csh for writing!\n";
   print FH "#!/bin/csh\n#\n#PBS -l mem=$global{memory},nodes=$global{nodes}\n#PBS -e $global{epath}\n#PBS -o $global{opath}\ncd $wd\n";
   $numberscripts++;
  }
  if (($jobnum < $maxjobsinscript && (not (-e $tmpfile))) || $redo == 1){
   s/^\/.+\/apps/$global{mead_path}\/apps/g;
   print $_;
   print FH $_."\n";
   $jobnum++;
   $numberjobs++;
  } 
 }
}

if ($jobnum <= $maxjobsinscript && $jobnum != 0){close (FH); system ("$global{qsub} -N $jobname -l mem=$global{memory} gcem_job.csh");}

print "\n\nsubmitted $numberscripts scripts containing $numberjobs jobs.\n";  
