#!/bin/csh 

# comparison of membrane potential computed with the CHARMM PBEQ module or MEAD my_membpot_solver 

cd MEAD
 echo "MEAD ..."
 time ../../../test_merge/apps/my_membpot_solver/my_membpot_solver -blab3 -epsext 80 -epshead 20 -epscore 2 -epsin1 1 -epsin2 4 -eps1set qm_region -eps2set mm_region -eps3set cav -epsin3 80 -ionicstr1 0.15 -ionicstr2 0.15 -membpot 1 -membz -15.0 15.0 -15.0 15.0 -membhole 7.0 0.0 0.0 -pf channel kcsa >& kcsa_voltage.out
 cat kcsa_voltage.out | grep "^ (" | grep ")" | perl -p -e 's/\(|\)/ /g;' | awk '{printf("%4.1f   %.6E\n", $3, $4);}' > kcsa_voltage.dat
cd ..

cd CHARMM
 echo "CHARMM ..."
 time charmm < kcsa_voltage_bondi.inp > kcsa_voltage.out  
 cat kcsa_voltage_bondi.dat | awk '{printf("%4.1f   %.6E\n", $3, $4);}' > kcsa_voltage.dat
cd ..
