// -*- C++ -*-
#ifndef ElySphere_h
#define ElySphere_h 1

#include "MEAD/ElectrolyteEnvironment.h"

//!wrap!
class ElySphere : public ElectrolyteEnvironment_lett {
public:
  ElySphere() : ionic_str(0.0) {}  
  ElySphere (float ionic, float rad, Coord cntr);
  ~ElySphere () {}
  //!nowrap!
  virtual ElyCubeRep get_cuberep(const CubeLatSpec& clsp);
  virtual float ionic_strength() const {return ionic_str;}
  float get_radius() const {return radius;}
  Coord get_center() const {return center;}
private:
  float ionic_str;
  float radius;
  Coord center;
};

#endif

// ElySphere.h ends here
