/*  SiteSet is an associative array of AtomSets 
    keyed by SiteID -*- C++ -*-

    TRU, 2007

    Copyright (c) 1993--1995 by Donald Bashford.

    This source code file is part of the MEAD (Macroscopic
    Electrostatics with Atomic Detail) package of objects and
    programs.  MEAD is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 1, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file COPYING.  If not, write to
    the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA
    02139, USA.

    Donald Bashford can be contacted by electronic mail by the address,
    bashford@scripps.edu, or by paper mail at Department of Molecular
    Biology, The Scripps Research Institute, 10666 North Torrey Pines
    Road, La Jolla, California 92037.
*/

#include "MEAD_e/SiteSet.h"
#include "MEAD_e/globals.h"
#include <fstream>

typedef std::list<Atom>::iterator alitr;
typedef std::list<Atom>::const_iterator calitr;

SiteSet::SiteSet(const SiteSet& a)
: map<SiteID,AtomSet>(a), name(a.name)
{
}

SiteSet::SiteSet()
: name("")
{
}

SiteSet::SiteSet (const string& nm)
: name(nm)
{

}

SiteSet& SiteSet::operator=(const SiteSet& a)
{
  map<SiteID,AtomSet>::operator=(a);
  name = a.name;
  return *this;
}


// SiteSet.cc ends here
