#include "MEAD/UniformElectrolyte.h"
#include "MEAD/CubeLatSpec.h"
#include <iostream>

UniformElectrolyte::UniformElectrolyte(float ionstr)
: ElectrolyteEnvironment_lett(), ionic_str(ionstr)
{
}

ElyCubeRep
UniformElectrolyte::get_cuberep (const CubeLatSpec& cls)
{
  blab3 << "UniformElectrolyte::get_cuberep: called"
	<< "\nSet the whole cubic Electrolyte grid to " << ionic_str << endl;
  ElyCubeRep ecr(cls);
  int grid_dim = cls.get_grid_dim();
  int ncube = grid_dim*grid_dim*grid_dim;
  for (int h = 0; h<ncube; ++h)
    ecr[h] = ionic_str;
  ecr.declare_defined();
  return ecr;
}
// UniformElectrolyte.cc ends here
