/* -*- C++ -*-
  Some little functions that use function calls that are defined by
  posix, but not by standard C or C++.
  This file is a possible source of portability problems for non-posix
  systems (note the WIN32 ifdefs, for example).
*/

#define _POSIX_SOURCE

#include "MEAD/globals.h"
#include <string>
#include <iostream>


#ifdef WIN32
#include <io.h>
#else
#include <unistd.h>
#endif

int fexists (std::string name)
{
#ifdef WIN32
        return (_access( "ACCESS.C", 0 )) == -1 ? 0:1;

#else
  return name != "" && 0==access (name.c_str(), F_OK);
#endif
}

void fdelete (std::string name)
{
  if (-1 == unlink(name.c_str()))
    cout << "WARNING: ~ElecMolecule: couldn't delete " << name << "\n";
}

