/*  class CharmmID is a key type for an associative array of Atoms
    using the residue name and atom name as identifier as in CHARMM
    topology files for parsing of parameter files

    TRU 09.2007

    Copyright (c) 1993--1995 by Donald Bashford.

    This source code file is part of the MEAD (Macroscopic
    Electrostatics with Atomic Detail) package of objects and
    programs.  MEAD is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 1, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file COPYING.  If not, write to
    the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA
    02139, USA.

    Donald Bashford can be contacted by electronic mail by the address,
    bashford@scripps.edu, or by paper mail at Department of Molecular
    Biology, The Scripps Research Institute, 10666 North Torrey Pines
    Road, La Jolla, California 92037.
*/
#include "MEAD_e/CharmmID.h"

CharmmID::CharmmID()
: resname(), atname()
{
}

CharmmID::CharmmID(const string& rn, const string& an)
: resname(rn), atname(an)
{
}

ostream& CharmmID::print(ostream &ost) const
{
  ost << resname << "-" << atname;
  return ost;
}

// CharmmID.cc ends here
