#include "MEAD_e/UniformElectrolyte.h"
#include "MEAD_e/CubeLatSpec.h"
#include <iostream>

UniformElectrolyte::UniformElectrolyte(float ionstr)
: ElectrolyteEnvironment_lett(), ionic_str(ionstr)
{
}

ElyCubeRep
UniformElectrolyte::get_cuberep (const CubeLatSpec& cls)
{
  blab3 << "UniformElectrolyte::get_cuberep: called"
	<< "\nSet the whole cubic Electrolyte grid to " << ionic_str << endl;
  ElyCubeRep dcr(cls);
  int grid_dim = cls.get_grid_dim();
  int ncube = grid_dim*grid_dim*grid_dim;
  for (int h = 0; h<ncube; ++h)
    dcr[h] = ionic_str;
  dcr.declare_defined();
  return dcr;
}
// UniformElectrolyte.cc ends here
