// mead.i Interface-file for all object needed to be wrapped for mead

%module mead


%header %{
#include "MEAD/ChargeDist.h"
#include "MEAD/AccTag.h"
#include "MEAD/AnalyMaker.h"
#include "MEAD/AnalySlab.h"
#include "MEAD/AnalySphere.h"
#include "MEAD/Angle.h"
#include "MEAD/AtomChargeSet.h"
#include "MEAD/Atom.h"
#include "MEAD/AtomID.h"
#include "MEAD/AtomSet.h"
#include "MEAD/AvsScalarField.h"
#include "MEAD/Bigmem.h"
#include "MEAD/CenteringStyle.h"
#include "MEAD/ChargeCubeRep.h"
#include "MEAD/CLShell.h"
#include "MEAD/Cone.h"
#include "MEAD/Coord.h"
#include "MEAD/CubeLatSpec.h"
#include "MEAD/Debye.h"
#include "MEAD/DielByAtoms.h"
#include "MEAD/DielCubeRep.h"
#include "MEAD/DielectricEnvironment.h"
#include "MEAD/DielectricSlab.h"
#include "MEAD/DielectricSphere.h"
#include "MEAD/DielMembAtoms.h"
#include "MEAD/ElectrolyteByAtoms.h"
#include "MEAD/ElectrolyteEnvironment.h"
#include "MEAD/ElstatMaker.h"
#include "MEAD/ElstatPotCombination.h"
#include "MEAD/ElstatPot.h"
#include "MEAD/ElySphere.h"
#include "MEAD/FDChargeIterator.h"
#include "MEAD/FDElstatMaker.h"
#include "MEAD/FDGridLevel.h"
#include "MEAD/FinDiffElstatPot.h"
#include "MEAD/FinDiffMethod.h"
#include "MEAD/globals.h"
#include "MEAD/ManyPointCharge.h"
#include "MEAD/MEADexcept.h"
#include "MEAD/MomentAnalysis.h"
#include "MEAD/MomentAnalysis_tmplts.h"
#include "MEAD/NonUnif.h"
#include "MEAD/OnePointCharge.h"
#include "MEAD/PairGenBorn.h"
#include "MEAD/Pair.h"
#include "MEAD/PhysCond.h"
#include "MEAD/PointCharge.h"
#include "MEAD/Polynomial.h"
#include "MEAD/Potat.h"
#include "MEAD/Sausage.h"
#include "MEAD/Shell.h"
#include "MEAD/SolvAccVol.h"
#include "MEAD/SphericalHarmonic.h"
#include "MEAD/TPShell.h"
#include "MEAD/UniformDielectric.h"
#include "MEAD/UniformElectrolyte.h"
#include "MEAD/VertElem.h"
#include "MEAD/Vertex.h"

%}

%include exception.i
%include std_string.i
%include std_vector.i
%include std_map.i
%include std_pair.i
%include std_list.i
#%include "/usr/share/swig1.3/std/std_container.i"
#%include "/usr/share/swig1.3/std/std_iostream.i"
#%include std_complex.i
#%include std_iostream.i
%include std_common.i
#%include perlstrings.swg
%include jstring.i
%include stdint.i

%typemap(typecheck) float {
	$1 = 1;
}

#%typemap (in) std::string* (std::string temp) {
#  unsigned int len;
#  char *s;
#  s = SvPV($input, len);
#  temp.assign(s, len);
#  $1 = &temp;
#}


//*******************************************************************/
//                              ChargeDist.h
//*******************************************************************/
%{
#include "MEAD/ChargeDist.h"
%}

%rename(is_cd) ChargeDist::operator=(const ChargeDist&);
%rename(is_cdl) ChargeDist_lett::operator=(const ChargeDist_lett&);

%include "MEAD/ChargeDist.h"

//*******************************************************************/
//                              DielectricEnvironment.h
//*******************************************************************/
%{
#include "MEAD/DielectricEnvironment.h"
%}

%rename(is_de) DielectricEnvironment::operator=(const DielectricEnvironment&);
%rename(is_del) DielectricEnvironment_lett::operator=(const DielectricEnvironment_lett&);

%include "MEAD/DielectricEnvironment.h"


//*******************************************************************/
//                              ElectrolyteEnvironment.h
//*******************************************************************/
%{
#include "MEAD/ElectrolyteEnvironment.h"
%}

%rename(is_ee) ElectrolyteEnvironment::operator=(const ElectrolyteEnvironment&);
%rename(is_eel) ElectrolyteEnvironment_lett::operator=(const ElectrolyteEnvironment_lett&);

%include "MEAD/ElectrolyteEnvironment.h"


//*******************************************************************/
//                              ElstatPot.h
//*******************************************************************/
%{
#include "MEAD/ElstatPot.h"
%}

%rename(mul_cd_ep) operator*(const ChargeDist&, const ElstatPot&);
%rename(mul_cd_epl) operator*(const ChargeDist&, const ElstatPot_lett&);
%rename(mul_ep_cdl) operator*(const ElstatPot&, const ChargeDist_lett&);
%rename(mul_epl_cdl) operator*(const ElstatPot_lett&, const ChargeDist_lett&);

%rename(mul_ep_cd) operator*(const ElstatPot&, const ChargeDist&);
%rename(mul_epl_cd) operator*(const ElstatPot_lett&, const ChargeDist&);
%rename(mul_cdl_ep) operator*(const ChargeDist_lett&, const ElstatPot&);
%rename(mul_cdl_epl) operator*(const ChargeDist_lett&, const ElstatPot_lett&);

%rename(is_ep) ElstatPot::operator=(const ElstatPot&);
%rename(is_epl) ElstatPot_lett::operator=(const ElstatPot_lett&);

%include "MEAD/ElstatPot.h"


//*******************************************************************/
//                              AnalySlab.h
//*******************************************************************/
//%{
//#include "MEAD/AnalySlab.h"
//%}

//%include "MEAD/AnalySlab.h"

//*******************************************************************/
//                              AnalySphere.h
//*******************************************************************/
//%{
//#include "MEAD/AnalySphere.h"
//%}

//%include "MEAD/AnalySphere.h"

//*******************************************************************/
//                              Atom.h
//*******************************************************************/
%{
#include "MEAD/Atom.h"
%}

%rename(is_a) Atom::operator=(const Atom& a);
%rename(eq_a) Atom::operator==(const Atom& b) const;
%rename(neq_a) Atom::operator!=(const Atom&) const;
%rename(os_a) operator<<(ostream&, const Atom&);
%rename(lt_a) operator<(const Atom&, const Atom&);
%rename(gt_a) operator>(const Atom&, const Atom&);

%include "MEAD/Atom.h"

//*******************************************************************/
//                              AtomID.h
//*******************************************************************/
%{
#include "MEAD/AtomID.h"
%}

%rename(is_aid) AtomID::operator=(const AtomID& a);
%rename(eq_aid) AtomID::operator==(const AtomID& b) const;
%rename(neq_aid) AtomID::operator!=(const AtomID&) const;
%rename(lt_aid) AtomID::operator<(const AtomID&) const;
%rename(gt_aid) AtomID::operator>(const AtomID&) const;
%rename(os_aid) operator<<(ostream&, AtomID);

%include "MEAD/AtomID.h"


//*******************************************************************/
//                              AtomSet.h
//*******************************************************************/
%{
#include "MEAD/AtomSet.h"
%}

%rename(is_as) AtomSet::operator=(const AtomSet&);
%rename(getAt_aid) AtomSet::operator[](const AtomID&);
%rename(getAt_aid_2) AtomSet::operator[](const AtomID&) const;


%include "MEAD/AtomSet.h"


%inline %{
AtomSet unite_as_as(const AtomSet& a1, const AtomSet& a2) {
  AtomSet u(a1);
  for (AtomSet::const_iterator i = a2.begin(); i!=a2.end(); ++i) {
  const Atom& a = i->second;
  AtomID k = i->first;
  if (a1.contains(k)) {
    cerr << "WARNING:  The atom, \"" << k
	<< "\",\n   occurs in both the solute and protein atom sets.\n"
	<< "   For defining the Elelctrolyte boundary, the protein version\n"
	<< "   will be used."  << endl;
  }
  else {
    u.insert(a);
  }
  }
  return u;
}
%}


//*******************************************************************/
//                              AtomChargeSet.h
//*******************************************************************/
%{
#include "MEAD/AtomChargeSet.h"
%}

%rename(is_acs) AtomChargeSet::operator=(const AtomChargeSet&);

%include "MEAD/AtomChargeSet.h"


//*******************************************************************/
//                              AvsScalarField.h
//*******************************************************************/
%{
#include "MEAD/AvsScalarField.h"
%}

%include "MEAD/AvsScalarField.h"



//*******************************************************************/
//                              CenteringStyle.h
//*******************************************************************/
%{
#include "MEAD/CenteringStyle.h"
%}

%include "MEAD/CenteringStyle.h"


//*******************************************************************/
//                              Coord.h
//*******************************************************************/
%{
#include "MEAD/Coord.h"
%}

%rename(is_c) Coord::operator=(const Coord&);
%rename(plusIs_c) Coord::operator+=(const Coord&);
%rename(minusIs_c) Coord::operator-=(const Coord&);
%rename(mulIs_c) Coord::operator*=(float);
%rename(divIs_c) Coord::operator/=(float);
%rename(neg_c) operator-() const;
%rename(gt_c) Coord::operator>(const Coord&) const;
%rename(lt_c) Coord::operator<(const Coord&) const;

%rename(plus_c) operator+(const Coord&, const Coord&);
%rename(minus_c) operator-(const Coord&, const Coord&);
%rename(mul_c_c) operator*(const Coord&, const Coord&);
%rename(mul_c_f) operator*(const Coord&, float);
%rename(mul_f_c) operator*(float, const Coord&);
%rename(div_c) operator/(const Coord&, float);
%rename(eq_c) operator==(const Coord&, const Coord&);
%rename(neq_c) operator!=(const Coord&, const Coord&);
%rename(out_c) operator<<(ostream&, Coord);
%rename(in_c) operator>>(istream&, Coord&);

%inline %{
void write_c(Coord& c) {
c.print(cout);
}
%}

%include "MEAD/Coord.h"

//*******************************************************************/
//                              CubeLatSpec.h
//*******************************************************************/
%{
#include "MEAD/CubeLatSpec.h"
%}

%rename(is_cls) CubeLatSpec::operator=(const CubeLatSpec&);
%rename(eq_cls) CubeLatSpec::operator==(const CubeLatSpec&);
%rename(lt_cls) CubeLatSpec::operator<(const CubeLatSpec&);
%rename(gt_cls) CubeLatSpec::operator>(const CubeLatSpec&);
%rename(os_cls) operator<<(ostream&, const CubeLatSpec&);

%include "MEAD/CubeLatSpec.h"

//*******************************************************************/
//                              Debye.h
//*******************************************************************/
%{
#include "MEAD/Debye.h"
%}

%include "MEAD/Debye.h"


//*******************************************************************/
//                              DielByAtoms.h
//*******************************************************************/
%{
#include "MEAD/DielByAtoms.h"
%}

%include "MEAD/DielByAtoms.h"


//*******************************************************************/
//                              DielCubeRep.h
//*******************************************************************/
%{
#include "MEAD/DielCubeRep.h"
%}

%include "MEAD/DielCubeRep.h"


//*******************************************************************/
//                              DielectricSlab.h
//*******************************************************************/
%{
#include "MEAD/DielectricSlab.h"
%}

%include "MEAD/DielectricSlab.h"

//*******************************************************************/
//                              DielectricSphere.h
//*******************************************************************/
%{
#include "MEAD/DielectricSphere.h"
%}

%include "MEAD/DielectricSphere.h"

//*******************************************************************/
//                              DielMembAtoms.h
//*******************************************************************/
%{
#include "MEAD/DielMembAtoms.h"
%}

%include "MEAD/DielMembAtoms.h"

//*******************************************************************/
//                              ElectrolyteByAtoms.h
//*******************************************************************/
%{
#include "MEAD/ElectrolyteByAtoms.h"
%}

%include "MEAD/ElectrolyteByAtoms.h"


//*******************************************************************/
//                              ElstatPotCombination.h
//*******************************************************************/
%{
#include "MEAD/ElstatPotCombination.h"
%}

%rename(is_epc) ElstatPotCombination::operator=(const ElstatPotCombination&);
%rename(plusIs_epc) ElstatPotCombination::operator+=(const ElstatPotCombination&);
%rename(plusIs_ep) ElstatPotCombination::operator+=(ElstatPot&);
%rename(plusIs_epl) ElstatPotCombination::operator+=(ElstatPot_lett&);

%rename(mul_f) ElstatPotCombination::operator*=(float);
%rename(div_f) ElstatPotCombination::operator/=(float);

%rename(mul_ep_f) operator*(ElstatPot&, float);
%rename(mul_f_ep) operator*(float, ElstatPot&);
%rename(mul_epl_f) operator*(ElstatPot_lett&, float);
%rename(mul_f_epl) operator*(float, ElstatPot_lett&);

%rename(div_ep_f) operator/(ElstatPot&, float);
%rename(div_epl_f) operator/(ElstatPot_lett&, float);

%rename(plus_epl_epl) operator+(ElstatPot_lett&, ElstatPot_lett&);
%rename(plus_epl_ep) operator+(ElstatPot_lett&, ElstatPot&);
%rename(plus_ep_epl) operator+(ElstatPot&, ElstatPot_lett&);
%rename(plus_ep_ep) operator+(ElstatPot&, ElstatPot&);
%rename(plus_epc_epc) operator+(const ElstatPotCombination&, const ElstatPotCombination&);
%rename(plus_epc_epl) operator+(const ElstatPotCombination&, ElstatPot_lett&);
%rename(plus_epl_epc) operator+(ElstatPot_lett&, const ElstatPotCombination&);
%rename(plus_epc_ep) operator+(const ElstatPotCombination&, ElstatPot&);
%rename(plus_ep_epc) operator+(ElstatPot&, const ElstatPotCombination&);

%rename(mul_epc_f) operator*(const ElstatPotCombination&, float);
%rename(mul_f_epc) operator*(float, const ElstatPotCombination&);

%rename(div_epc_float) operator/(const ElstatPotCombination&, float);
%rename(div_float_epc) operator/(float, const ElstatPotCombination&);

%rename(mul_cdl_epc) operator*(const ChargeDist_lett&, const ElstatPotCombination&);
%rename(mul_epc_cdl) operator*(const ElstatPotCombination&, const ChargeDist_lett&);

%include "MEAD/ElstatPotCombination.h"

//*******************************************************************/
//                              ElySphere.h
//*******************************************************************/
%{
#include "MEAD/ElySphere.h"
%}

%include "MEAD/ElySphere.h"


//*******************************************************************/
//                              FDGridLevel.h
//*******************************************************************/
%{
#include "MEAD/FDGridLevel.h"
%}

%include "MEAD/FDGridLevel.h"



//*******************************************************************/
//                              FinDiffElstatPot.h
//*******************************************************************/
%{
#include "MEAD/FinDiffElstatPot.h"
%}

%include "MEAD/FinDiffElstatPot.h"



//*******************************************************************/
//                              FinDiffMethod.h
//*******************************************************************/

%{
#include "MEAD/FinDiffMethod.h"
%}

%rename(is_fdm) FinDiffMethod::operator=(const FinDiffMethod&);
%rename(os_fdm) operator<<(ostream&, const FinDiffMethod&);

%include "MEAD/FinDiffMethod.h"

%inline %{
void write_fdm(const FinDiffMethod& f) {f.print(cout);}
%}

//*******************************************************************/
//                              ManyPointCharge.h
//*******************************************************************/
%{
#include "MEAD/ManyPointCharge.h"
%}

%rename(return_pc) point_to_point::operator()(const PointCharge&);

%include "MEAD/ManyPointCharge.h"

//*******************************************************************/
//                              MomentAnalysis.h
//*******************************************************************/
%{
#include "MEAD/MomentAnalysis.h"
%}

typedef complex< float > momtype

%rename(return_mt) Moments::operator()(int, int);
%rename(return_mt_2) const Moments::operator()(int, int);
%rename(minus) Moments::operator-() const;
%rename(plus_m) Moments::operator+(const Moments) const;
%rename(minus_m) Moments::operator-(const Moments) const;
%rename(mul_f) Moments::operator*(float) const;
%rename(mul_mt) Moments::operator*(momtype) const;
%rename(mul_f_m) operator*(float, const Moments&);


%include "MEAD/MomentAnalysis.h"

//*******************************************************************/
//                              OnePointCharge.h
//*******************************************************************/
%{
#include "MEAD/OnePointCharge.h"
%}

%rename(return_pc) operator PointCharge() const;

%include "MEAD/OnePointCharge.h"

//*******************************************************************/
//                              PhysCond.h
//*******************************************************************/
%{
#include "MEAD/PhysCond.h"
%}

%inline %{
void PhysCond_epsext_set(float x) {PhysCond::set_epsext(x);}
void PhysCond_solrad_set(float x) {PhysCond::set_solrad(x);}
void PhysCond_sterln_set(float x) {PhysCond::set_sterln(x);}
void PhysCond_ionicstr_set(float x) {PhysCond::set_ionicstr(x);}
void PhysCond_T_set(float x) {PhysCond::set_T(x);}
void PhysCond_kBolt_set(float x) {PhysCond::set_kBolt(x);}
void PhysCond_conconv_set(float x) {PhysCond::set_conconv(x);}
void PhysCond_econv_set(float x) {PhysCond::set_econv(x);}
void PhysCond_bohr_radius_set(float x) {PhysCond::set_bohr_radius(x);}
void PhysCond_proton_charge_set(float x) {PhysCond::set_proton_charge(x);}

float PhysCond_epsext_get() {return PhysCond::get_epsext();}
float PhysCond_solrad_get() {return PhysCond::get_solrad();}
float PhysCond_sterln_get() {return PhysCond::get_sterln();}
float PhysCond_ionicstr_get() {return PhysCond::get_ionicstr();}
float PhysCond_T_get() {return PhysCond::get_T();}
float PhysCond_kBolt_get() {return PhysCond::get_kBolt();}
float PhysCond_conconv_get() {return PhysCond::get_conconv();}
float PhysCond_econv_get() {return PhysCond::get_econv();}
float PhysCond_bohr_radius_get() {return PhysCond::get_bohr_radius();}
float PhysCond_proton_charge_get() {return PhysCond::get_proton_charge();}
float PhysCond_hueck_get() {return PhysCond::get_hueck();}
float PhysCond_kappasq_get() {return PhysCond::get_kappasq();}
float PhysCond_ln10kT_get() {return PhysCond::get_ln10kT();}

void PhysCond_print() {PhysCond::print();}
void blab1_set() {blab1pt = &cout;};
void blab2_set() {blab1pt = &cout;
		  blab2pt = &cout;};
void blab3_set() {blab1pt = &cout;
		  blab2pt = &cout;
		  blab2pt = &cout;};
		  
		  
%}

class PhysCond {

private:
  static float epsin1;
  static float epsin2;
  static float epsext;
  static float solrad;
  static float sterln;
  static float ionicstr;
  static float T;
  static float kBolt;
  static float conconv;
  static float econv;
  static float hueck;
  static float kappasq;
  static float ln10kT;
  static float bohr_radius;
  static float proton_charge;
};

//%include "MEAD/PhysCond.h"

//*******************************************************************/
//                              PointCharge.h
//*******************************************************************/
%{
#include "MEAD/PointCharge.h"
%}

%rename(eq_pc) PointCharge::operator==(const PointCharge&) const;
//%rename(neq_pcci) PointCharge_const_iterator::operator!=(const PointCharge_const_iterator&);
%rename(is_pcci) PointCharge_const_iterator::operator=(const PointCharge_const_iterator&);
%rename(incr_pcci) PointCharge_const_iterator::operator++();
%rename(neq_pcci) PointCharge_const_iterator::operator!=(const PointCharge_const_iterator&) const;

%include "MEAD/PointCharge.h"

//*******************************************************************/
//                              SolvAccVol.h
//*******************************************************************/
%{
#include "MEAD/SolvAccVol.h"
%}

%rename(is_sav) SolvAccVol::operator=(const SolvAccVol&);

%include "MEAD/SolvAccVol.h"

//*******************************************************************/
//                              SphericalHarmonic.h
//*******************************************************************/
%{
#include "MEAD/SphericalHarmonic.h"
%}

%rename(is_p) Poly::operator=(const Poly&);
%rename(return_p) Poly::operator()(float) const;
%rename(minus) Poly::operator-() const;
%rename(plus_p) Poly::operator+(const Poly&) const;
%rename(minus_p) Poly::operator-(const Poly&) const;
%rename(mul_p) Poly::operator*(const Poly&) const;
%rename(mul_f) Poly::operator*(float) const;
%rename(div_f) Poly::operator/(float) const;
%rename(eq_p) Poly::operator==(const Poly&) const;

%rename(mul_f_p) operator*(float, const Poly&);
%rename(os_p) operator<<(ostream&, const Poly&);

%rename(is_l) Legendre::operator=(const Legendre&);

%rename(is_al) AssocLegendre::operator=(const AssocLegendre&);
%rename(return_al) AssocLegendre::operator()(float) const;

%rename(os_al) operator<<(ostream&, const AssocLegendre&);

%rename(is_psh) PreSpheHarm::operator=(const PreSpheHarm&);

%rename(is_sh) SphericalHarmonic::operator=(const SphericalHarmonic&);
%rename(return_sh) SphericalHarmonic::operator()(float, float) const;

%rename(os_sh) operator<<(ostream&, const SphericalHarmonic&);

%rename(return_shs) SphericalHarmonic_series::operator()(int, int) const;

%include "MEAD/SphericalHarmonic.h"


//*******************************************************************/
//                              UniformDielectric.h
//*******************************************************************/
%{
#include "MEAD/UniformDielectric.h"
%}

%include "MEAD/UniformDielectric.h"

//*******************************************************************/
//                              UniformElectrolyte.h
//*******************************************************************/
%{
#include "MEAD/UniformElectrolyte.h"
%}

%include "MEAD/UniformElectrolyte.h"
